/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.ui;

import android.app.Activity;
import android.app.AlarmManager;
import android.app.AlertDialog;
import android.app.PendingIntent;
import android.app.SearchManager;
import android.appwidget.AppWidgetManager;
import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Paint;
import android.net.Uri;
import android.nfc.Tag;
import android.os.Build;
import android.os.Bundle;
import android.provider.DocumentsContract;
import android.preference.PreferenceManager;
import android.provider.MediaStore;
import android.text.Editable;
import android.text.Spannable;
import android.text.SpannableString;
import android.text.TextUtils;
import android.text.format.DateUtils;
import android.text.style.BackgroundColorSpan;
import android.text.style.ImageSpan;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import net.micode.notes.R;
import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.TextNote;
import net.micode.notes.model.WorkingNote;
import net.micode.notes.model.WorkingNote.NoteSettingChangedListener;
import net.micode.notes.tool.DataUtils;
import net.micode.notes.tool.FontColorParser;
import net.micode.notes.tool.ResourceParser;
import net.micode.notes.tool.ResourceParser.TextAppearanceResources;
import net.micode.notes.ui.DateTimePickerDialog.OnDateTimeSetListener;
import net.micode.notes.ui.NoteEditText.OnTextViewChangeListener;
import net.micode.notes.widget.NoteWidgetProvider_2x;
import net.micode.notes.widget.NoteWidgetProvider_4x;

import org.w3c.dom.Document;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


public class NoteEditActivity extends Activity implements OnClickListener,
        NoteSettingChangedListener, OnTextViewChangeListener {
    // 头部视图空间
    private class HeadViewHolder {
        // 文本视图，显示修改的日期
        public TextView tvModified;
        // 图像视图，显示警告图标
        public ImageView ivAlertIcon;
        // 文本视图，显示警告日期
        public TextView tvAlertDate;
        // 图像按钮，用于设置背景颜色
        public ImageView ibSetBgColor;
    }

    // 用于存储不同背景选择按钮的id和对应颜色
    private static final Map<Integer, Integer> sBgSelectorBtnsMap = new HashMap<Integer, Integer>();
    static {
        sBgSelectorBtnsMap.put(R.id.iv_bg_yellow, ResourceParser.YELLOW);
        sBgSelectorBtnsMap.put(R.id.iv_bg_red, ResourceParser.RED);
        sBgSelectorBtnsMap.put(R.id.iv_bg_blue, ResourceParser.BLUE);
        sBgSelectorBtnsMap.put(R.id.iv_bg_green, ResourceParser.GREEN);
        sBgSelectorBtnsMap.put(R.id.iv_bg_white, ResourceParser.WHITE);
    }

    // 用于存储不同颜色值和对应的背景选择器的id
    private static final Map<Integer, Integer> sBgSelectorSelectionMap = new HashMap<Integer, Integer>();
    static {
        sBgSelectorSelectionMap.put(ResourceParser.YELLOW, R.id.iv_bg_yellow_select);
        sBgSelectorSelectionMap.put(ResourceParser.RED, R.id.iv_bg_red_select);
        sBgSelectorSelectionMap.put(ResourceParser.BLUE, R.id.iv_bg_blue_select);
        sBgSelectorSelectionMap.put(ResourceParser.GREEN, R.id.iv_bg_green_select);
        sBgSelectorSelectionMap.put(ResourceParser.WHITE, R.id.iv_bg_white_select);
    }

    // 用于存储不同字体大小按钮id和对应的字体大小
    private static final Map<Integer, Integer> sFontSizeBtnsMap = new HashMap<Integer, Integer>();
    static {
        sFontSizeBtnsMap.put(R.id.ll_font_large, ResourceParser.TEXT_LARGE);
        sFontSizeBtnsMap.put(R.id.ll_font_small, ResourceParser.TEXT_SMALL);
        sFontSizeBtnsMap.put(R.id.ll_font_normal, ResourceParser.TEXT_MEDIUM);
        sFontSizeBtnsMap.put(R.id.ll_font_super, ResourceParser.TEXT_SUPER);
    }

    // 用于存储不同字体大小和对应的字体选择器的id
    private static final Map<Integer, Integer> sFontSelectorSelectionMap = new HashMap<Integer, Integer>();
    static {
        sFontSelectorSelectionMap.put(ResourceParser.TEXT_LARGE, R.id.iv_large_select);
        sFontSelectorSelectionMap.put(ResourceParser.TEXT_SMALL, R.id.iv_small_select);
        sFontSelectorSelectionMap.put(ResourceParser.TEXT_MEDIUM, R.id.iv_medium_select);
        sFontSelectorSelectionMap.put(ResourceParser.TEXT_SUPER, R.id.iv_super_select);
    }
    // 用于存储不同文本颜色的按钮id和对应文本颜色
    private static final Map<Integer, Integer> sTxtColorBtnsMaps = new HashMap<Integer, Integer>();
    static {
        sTxtColorBtnsMaps.put(R.id.ll_font_default, FontColorParser.Default);
        sTxtColorBtnsMaps.put(R.id.ll_font_green, FontColorParser.green);
        sTxtColorBtnsMaps.put(R.id.ll_font_red, FontColorParser.red);
        sTxtColorBtnsMaps.put(R.id.ll_font_Bright_blue, FontColorParser.Bright_blue);
    }
    // 用于存储不同文本颜色和其对应选择器id
    private static final Map<Integer, Integer> sTxtColorSelectorSelectionMap = new HashMap<Integer, Integer>();
    static {
        sTxtColorSelectorSelectionMap.put(FontColorParser.Default ,R.id.iv_default_select);
        sTxtColorSelectorSelectionMap.put(FontColorParser.red ,R.id.iv_red_select);
        sTxtColorSelectorSelectionMap.put(FontColorParser.Bright_blue ,R.id.iv_Bright_blue_select);
        sTxtColorSelectorSelectionMap.put(FontColorParser.green ,R.id.iv_green_select);
    }
    private static final String TAG = "NoteEditActivity";
    // 存储笔记的头部视图
    private HeadViewHolder mNoteHeaderHolder;
    // 存储头部视图图面板
    private View mHeadViewPanel;

    private View mNoteBgColorSelector;
    private View mTxtColorSelector;
    private View mFontSizeSelector;
    // 用于存储笔记编辑器
    private EditText mNoteEditor;
    // 用于存储笔记编辑面板
    private View mNoteEditorPanel;
    // 用于存储正在编辑的笔记
    private WorkingNote mWorkingNote;
    // 用于存储用户的偏好设置
    private SharedPreferences mSharedPrefs;
    private int mTxtColorId;
    private int mFontSizeId;
    // 用于表示字体大小偏好设置键
    private static final String PREFERENCE_TXT_COLOR = "pref_font_color";
    private static final String PREFERENCE_FONT_SIZE = "pref_font_size";
    // 用于限制快捷方式图标标题的最大长度
    private static final int SHORTCUT_ICON_TITLE_MAX_LEN = 10;
    // 表示已被选中的标签符号
    public static final String TAG_CHECKED = String.valueOf('\u221A');
    // 表示未被选中的标签符号
    public static final String TAG_UNCHECKED = String.valueOf('\u25A1');
    // 用于唤出相册操作
    public final int OPEN_GALLERY = 1;
    // 用于存储文本编辑列表
    private LinearLayout mEditTextList;

    // 用于存储用户的输入内容
    private String mUserQuery;

    private Pattern mPattern;

    // 在活动创建时进行一些初始化操作
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        this.setContentView(R.layout.note_edit);

        // 如果传入的参数为空，且调用initActivityState方法传入getIntent方法返回的Intent对象返回false，
        // 表示活动状态初始化失败，结束活动
        if (savedInstanceState == null && !initActivityState(getIntent())) {
            finish();
            return;
        }
        // 初始化一些资源
        initResources();
    }

    /**
     * Current activity may be killed when the memory is low. Once it is killed, for another time
     * user load this activity, we should restore the former state
     */
    // 为防止内存不足时程序的终止，在这里有一个保存现场的函数
    // 用于在活动恢复时执行一些操作
    @Override
    protected void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);
        if (savedInstanceState != null && savedInstanceState.containsKey(Intent.EXTRA_UID)) {
            // 创建一个新的Intent对象，设置其动作为Intent.ACTION_VIEW
            Intent intent = new Intent(Intent.ACTION_VIEW);
            // 将Intent.EXTRA_UID作为额外数据放入intent对象中
            intent.putExtra(Intent.EXTRA_UID, savedInstanceState.getLong(Intent.EXTRA_UID));
            // 如果初始化活动失败则结束活动
            if (!initActivityState(intent)) {
                finish();
                return;
            }
            // 打印一条调试信息，表示从被杀死的活动中恢复
            Log.d(TAG, "Restoring from killed activity");
        }
    }

    // 用于返回活动初始化状态
    private boolean initActivityState(Intent intent) {
        /**
         * If the user specified the {@link Intent#ACTION_VIEW} but not provided with id,
         * then jump to the NotesListActivity
         */
        mWorkingNote = null;
        if (TextUtils.equals(Intent.ACTION_VIEW, intent.getAction())) {
            long noteId = intent.getLongExtra(Intent.EXTRA_UID, 0);
            mUserQuery = "";

            /**
             * Starting from the searched result
             */
            // 根据键值查找ID
            if (intent.hasExtra(SearchManager.EXTRA_DATA_KEY)) {
                noteId = Long.parseLong(intent.getStringExtra(SearchManager.EXTRA_DATA_KEY));
                mUserQuery = intent.getStringExtra(SearchManager.USER_QUERY);
            }
            // 如果在内容提供者中，noteId对应的笔记不可见或者不是笔记类型
            if (!DataUtils.visibleInNoteDatabase(getContentResolver(), noteId, Notes.TYPE_NOTE)) {
                Intent jump = new Intent(this, NotesListActivity.class);
                //程序将跳转到上面声明的intent——jump
                startActivity(jump);
                showToast(R.string.error_note_not_exist);
                finish();
                return false;
            } else {
                // 否则向 load函数 传入当前活动和noteId作为参数，返回一个WorkingNote对象
                mWorkingNote = WorkingNote.load(this, noteId);
                // 如果正在编辑的笔记为空
                if (mWorkingNote == null) {
                    Log.e(TAG, "load note failed with note id" + noteId);
                    finish();
                    return false;
                }
            }
            // 获取当前活动的窗口对象，设置软输入状态为隐藏状态并调整大小
            getWindow().setSoftInputMode(
                    WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN
                            | WindowManager.LayoutParams.SOFT_INPUT_ADJUST_RESIZE);
        } else if(TextUtils.equals(Intent.ACTION_INSERT_OR_EDIT, intent.getAction())) {
            // New note
            long folderId = intent.getLongExtra(Notes.INTENT_EXTRA_FOLDER_ID, 0);
            int widgetId = intent.getIntExtra(Notes.INTENT_EXTRA_WIDGET_ID,
                    AppWidgetManager.INVALID_APPWIDGET_ID);
            int widgetType = intent.getIntExtra(Notes.INTENT_EXTRA_WIDGET_TYPE,
                    Notes.TYPE_WIDGET_INVALIDE);
            int bgResId = intent.getIntExtra(Notes.INTENT_EXTRA_BACKGROUND_ID,
                    ResourceParser.getDefaultBgId(this));

            // Parse call-record note
            String phoneNumber = intent.getStringExtra(Intent.EXTRA_PHONE_NUMBER);
            long callDate = intent.getLongExtra(Notes.INTENT_EXTRA_CALL_DATE, 0);
            if (callDate != 0 && phoneNumber != null) {
                if (TextUtils.isEmpty(phoneNumber)) {
                    Log.w(TAG, "The call record number is null");
                }
                long noteId = 0;
                if ((noteId = DataUtils.getNoteIdByPhoneNumberAndCallDate(getContentResolver(),
                        phoneNumber, callDate)) > 0) {
                    mWorkingNote = WorkingNote.load(this, noteId);
                    if (mWorkingNote == null) {
                        Log.e(TAG, "load call note failed with note id" + noteId);
                        finish();
                        return false;
                    }
                } else {
                    mWorkingNote = WorkingNote.createEmptyNote(this, folderId, widgetId,
                            widgetType, bgResId);
                    // 将空笔记转换为通话笔记
                    mWorkingNote.convertToCallNote(phoneNumber, callDate);
                }
            } else {
                mWorkingNote = WorkingNote.createEmptyNote(this, folderId, widgetId, widgetType,
                        bgResId);
            }

            getWindow().setSoftInputMode(
                    WindowManager.LayoutParams.SOFT_INPUT_ADJUST_RESIZE
                            | WindowManager.LayoutParams.SOFT_INPUT_STATE_VISIBLE);
        } else {
            Log.e(TAG, "Intent not specified action, should not support");
            finish();
            return false;
        }
        // 设置其设置状态为改变监听器
        mWorkingNote.setOnSettingStatusChangedListener(this);
        return true;
    }

    @Override
    protected void onResume() {
        super.onResume();
        initNoteScreen();
    }

    // 用于初始化笔记的界面和功能
    private void initNoteScreen() {
        // 设置笔记编辑器的文字外观，根据字体大小的id选择合适的资源
        mNoteEditor.setTextAppearance(this, TextAppearanceResources
                .getTexAppearanceResource(mFontSizeId));
        // 设置外观
        if (mWorkingNote.getCheckListMode() == TextNote.MODE_CHECK_LIST) {
            switchToListMode(mWorkingNote.getContent());
        } else {
            mNoteEditor.setText(getHighlightQueryResult(mWorkingNote.getContent(), mUserQuery));
            mNoteEditor.setSelection(mNoteEditor.getText().length());
        }
        for (Integer id : sBgSelectorSelectionMap.keySet()) {
            findViewById(sBgSelectorSelectionMap.get(id)).setVisibility(View.GONE);
        }
        mHeadViewPanel.setBackgroundResource(mWorkingNote.getTitleBgResId());
        mNoteEditorPanel.setBackgroundResource(mWorkingNote.getBgColorResId());

        mNoteHeaderHolder.tvModified.setText(DateUtils.formatDateTime(this,
                mWorkingNote.getModifiedDate(), DateUtils.FORMAT_SHOW_DATE
                        | DateUtils.FORMAT_NUMERIC_DATE | DateUtils.FORMAT_SHOW_TIME
                        | DateUtils.FORMAT_SHOW_YEAR));

        /**
         * TODO: Add the menu for setting alert. Currently disable it because the DateTimePicker
         * is not ready
         */
        showAlertHeader();
    }

    // 设置闹钟显示
    private void showAlertHeader() {
        // 判断当前笔记是否有闹钟提醒
        if (mWorkingNote.hasClockAlert()) {
            long time = System.currentTimeMillis();
            // 如果系统时间大于闹钟设置的时间，则闹钟时间设置为在系统时间的基础上加一个时间跨度
            if (time > mWorkingNote.getAlertDate()) {
                mNoteHeaderHolder.tvAlertDate.setText(R.string.note_alert_expired);
            } else {
                mNoteHeaderHolder.tvAlertDate.setText(DateUtils.getRelativeTimeSpanString(
                        mWorkingNote.getAlertDate(), time, DateUtils.MINUTE_IN_MILLIS));
            }
            // 显示闹钟的开始图标
            mNoteHeaderHolder.tvAlertDate.setVisibility(View.VISIBLE);
            mNoteHeaderHolder.ivAlertIcon.setVisibility(View.VISIBLE);
        } else {
            // 如果当前的笔记没有闹钟提醒，就将警告日期文本和警告图标设置为不可见
            mNoteHeaderHolder.tvAlertDate.setVisibility(View.GONE);
            mNoteHeaderHolder.ivAlertIcon.setVisibility(View.GONE);
        };
    }

    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        initActivityState(intent);
    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
        /**
         * For new note without note id, we should firstly save it to
         * generate a id. If the editing note is not worth saving, there
         * is no id which is equivalent to create new note
         */
        //在创建一个新的标签时，先在数据库中匹配
        //如果不存在，那么先在数据库中存储
        if (!mWorkingNote.existInDatabase()) {
            saveNote();
        }
        outState.putLong(Intent.EXTRA_UID, mWorkingNote.getNoteId());
        Log.d(TAG, "Save working note id: " + mWorkingNote.getNoteId() + " onSaveInstanceState");
    }

    //用于分发触摸事件到合适的视图中
    @Override
    public boolean dispatchTouchEvent(MotionEvent ev) {
        // 判断当前笔记的颜色选择器在屏幕上是否可见，且在可触控范围内
        if (mNoteBgColorSelector.getVisibility() == View.VISIBLE
                && !inRangeOfView(mNoteBgColorSelector, ev)) {
            mNoteBgColorSelector.setVisibility(View.GONE);
            return true;
        }
        // 判断当前笔记的字体大小选择器是否可见，且在触控范围内
        if (mFontSizeSelector.getVisibility() == View.VISIBLE
                && !inRangeOfView(mFontSizeSelector, ev)) {
            mFontSizeSelector.setVisibility(View.GONE);
            return true;
        }
        // 如果两个选择器在屏幕都不可见，则重新分配触发事件
        return super.dispatchTouchEvent(ev);
    }

    // 对屏幕触控的坐标进行操作
    private boolean inRangeOfView(View view, MotionEvent ev) {
        int []location = new int[2];
        view.getLocationOnScreen(location);
        int x = location[0];
        int y = location[1];
        // 如果触控的位置超出了给定的范围
        if (ev.getX() < x
                || ev.getX() > (x + view.getWidth())
                || ev.getY() < y
                || ev.getY() > (y + view.getHeight())) {
                    return false;
                }
        return true;
    }

    //对标签各项属性内容的初始化
    private void initResources() {
        mHeadViewPanel = findViewById(R.id.note_title);
        mNoteHeaderHolder = new HeadViewHolder();
        mNoteHeaderHolder.tvModified = (TextView) findViewById(R.id.tv_modified_date);
        mNoteHeaderHolder.ivAlertIcon = (ImageView) findViewById(R.id.iv_alert_icon);
        mNoteHeaderHolder.tvAlertDate = (TextView) findViewById(R.id.tv_alert_date);
        mNoteHeaderHolder.ibSetBgColor = (ImageView) findViewById(R.id.btn_set_bg_color);
        mNoteHeaderHolder.ibSetBgColor.setOnClickListener(this);
        mNoteEditor = (EditText) findViewById(R.id.note_edit_view);
        mNoteEditorPanel = findViewById(R.id.sv_note_edit);
        mNoteBgColorSelector = findViewById(R.id.note_bg_color_selector);
        for (int id : sBgSelectorBtnsMap.keySet()) {
            ImageView iv = (ImageView) findViewById(id);
            iv.setOnClickListener(this);
        }

        //对字体大小的选择
        mFontSizeSelector = findViewById(R.id.font_size_selector);
        for (int id : sFontSizeBtnsMap.keySet()) {
            View view = findViewById(id);
            view.setOnClickListener(this);
        }

        mTxtColorSelector = findViewById(R.id.ll_font_color_selector);
        for (int id : sTxtColorBtnsMaps.keySet()) {
            View view = findViewById(id);
            view.setOnClickListener(this);
        }

        mSharedPrefs = PreferenceManager.getDefaultSharedPreferences(this);
        mFontSizeId = mSharedPrefs.getInt(PREFERENCE_FONT_SIZE, ResourceParser.BG_DEFAULT_FONT_SIZE);
        mTxtColorId = mSharedPrefs.getInt(PREFERENCE_TXT_COLOR, FontColorParser.Font_color_default);
        /**
         * HACKME: Fix bug of store the resource id in shared preference.
         * The id may larger than the length of resources, in this case,
         * return the {@link ResourceParser#BG_DEFAULT_FONT_SIZE}
         */
        if(mFontSizeId >= TextAppearanceResources.getResourcesSize()) {
            mFontSizeId = ResourceParser.BG_DEFAULT_FONT_SIZE;
        }
        if(mTxtColorId >= FontColorParser.TextAppearanceResources.getResourceSize()) {
            mTxtColorId = FontColorParser.Font_color_default;
        }
        mEditTextList = (LinearLayout) findViewById(R.id.note_edit_list);
    }

    @Override
    protected void onPause() {
        super.onPause();
        // 尝试保存当前笔记数据，并判断是否保持成功
        if(saveNote()) {
            Log.d(TAG, "Note data was saved with length:" + mWorkingNote.getContent().length());
        }
        // 清除一些设置状态
        clearSettingState();
    }

    // 与桌面小部件的内容和外观同步
    private void updateWidget() {
        Intent intent = new Intent(AppWidgetManager.ACTION_APPWIDGET_UPDATE);
        if (mWorkingNote.getWidgetType() == Notes.TYPE_WIDGET_2X) {
            intent.setClass(this, NoteWidgetProvider_2x.class);
        } else if (mWorkingNote.getWidgetType() == Notes.TYPE_WIDGET_4X) {
            intent.setClass(this, NoteWidgetProvider_4x.class);
        } else {
            Log.e(TAG, "Unspported widget type");
            return;
        }

        intent.putExtra(AppWidgetManager.EXTRA_APPWIDGET_IDS, new int[] {
            mWorkingNote.getWidgetId()
        });

        sendBroadcast(intent);
        setResult(RESULT_OK, intent);
    }

    // 在一个视图被点击时调用
    public void onClick(View v) {
        // 获取被点击的视图的id
        int id = v.getId();
        // 如果是背景颜色的按钮，则将背景颜色选择器和当前笔记背景颜色对应的视图设为可见
        if (id == R.id.btn_set_bg_color) {
            mNoteBgColorSelector.setVisibility(View.VISIBLE);
            findViewById(sBgSelectorSelectionMap.get(mWorkingNote.getBgColorId())).setVisibility(
                                        View.VISIBLE);
        } else if (sBgSelectorBtnsMap.containsKey(id)) {
            findViewById(sBgSelectorSelectionMap.get(mWorkingNote.getBgColorId())).setVisibility(
                    View.GONE);
            mWorkingNote.setBgColorId(sBgSelectorBtnsMap.get(id));
            mNoteBgColorSelector.setVisibility(View.GONE);
        } else if (sFontSizeBtnsMap.containsKey(id)) {
            findViewById(sFontSelectorSelectionMap.get(mFontSizeId)).setVisibility(View.GONE);
            mFontSizeId = sFontSizeBtnsMap.get(id);
            mSharedPrefs.edit().putInt(PREFERENCE_FONT_SIZE, mFontSizeId).commit();
            findViewById(sFontSelectorSelectionMap.get(mFontSizeId)).setVisibility(View.VISIBLE);
            if (mWorkingNote.getCheckListMode() == TextNote.MODE_CHECK_LIST) {
                getWorkingText();
                switchToListMode(mWorkingNote.getContent());
            } else {
                mNoteEditor.setTextAppearance(this,
                        TextAppearanceResources.getTexAppearanceResource(mFontSizeId));
            }
            mFontSizeSelector.setVisibility(View.GONE);
        } else if (sTxtColorBtnsMaps.containsKey(id)) {
            findViewById(sTxtColorSelectorSelectionMap.get(mTxtColorId)).setVisibility(View.GONE);
            mTxtColorId = sTxtColorBtnsMaps.get(id);
            mSharedPrefs.edit().putInt(PREFERENCE_TXT_COLOR, mTxtColorId).commit();
            findViewById(sTxtColorSelectorSelectionMap.get(mTxtColorId)).setVisibility(View.VISIBLE);
            if (mWorkingNote.getCheckListMode() == TextNote.MODE_CHECK_LIST) {
                getWorkingText();
                switchToListMode(mWorkingNote.getContent());
            } else {
                mNoteEditor.setTextAppearance(this,
                        FontColorParser.TextAppearanceResources.getTexAppearanceResource(mTxtColorId));
            }
            mTxtColorSelector.setVisibility(View.GONE);
        } else if (id == R.id.menu_insert_img) {
            openGallery();
        }
    }

    // 当按下返回键时执行操作
    @Override
    public void onBackPressed() {
        if(clearSettingState()) {
            return;
        }

        saveNote();
        super.onBackPressed();
    }

    // 用于清除一些设置状态
    private boolean clearSettingState() {
        if (mNoteBgColorSelector.getVisibility() == View.VISIBLE) {
            mNoteBgColorSelector.setVisibility(View.GONE);
            return true;
        } else if (mFontSizeSelector.getVisibility() == View.VISIBLE) {
            mFontSizeSelector.setVisibility(View.GONE);
            return true;
        }
        return false;
    }

    // 在改变背景颜色时执行的操作
    public void onBackgroundColorChanged() {
        findViewById(sBgSelectorSelectionMap.get(mWorkingNote.getBgColorId())).setVisibility(
                View.VISIBLE);
        mNoteEditorPanel.setBackgroundResource(mWorkingNote.getBgColorResId());
        mHeadViewPanel.setBackgroundResource(mWorkingNote.getTitleBgResId());
    }

    // 在准备选择菜单执行的操作
    @Override
    public boolean onPrepareOptionsMenu(Menu menu) {
        // 判断Activity是否正在结束
        if (isFinishing()) {
            return true;
        }
        clearSettingState();
        // 清空菜单所有项目
        menu.clear();
        // 判断当前笔记的文件夹id是否是通话记录文件夹的id
        if (mWorkingNote.getFolderId() == Notes.ID_CALL_RECORD_FOLDER) {
            // 加载通话记录编辑菜单的资源
            getMenuInflater().inflate(R.menu.call_note_edit, menu);
        } else {
            // 加载普通笔记编辑菜单的资源
            getMenuInflater().inflate(R.menu.note_edit, menu);
        }
        // 笔记是否处于清单模式
        if (mWorkingNote.getCheckListMode() == TextNote.MODE_CHECK_LIST) {
            // 将菜单中的列表模式项目的标题设置为普通模式
            menu.findItem(R.id.menu_list_mode).setTitle(R.string.menu_normal_mode);
        } else {
            // 将菜单中的列表模式项目的标题设置为列表模式
            menu.findItem(R.id.menu_list_mode).setTitle(R.string.menu_list_mode);
        }
        // 判断当前笔记是否有闹钟提醒
        if (mWorkingNote.hasClockAlert()) {
            // 将菜单中的提醒项目设置为不可见
            menu.findItem(R.id.menu_alert).setVisible(false);
        } else {
            // 将菜单中的删除提醒项目设置为不可见
            menu.findItem(R.id.menu_delete_remind).setVisible(false);
        }
        return true;
    }

    // 当选择菜单中的某个项目被点击调用时的操作
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // 根据被点击项目的id，进行不同的处理
        switch (item.getItemId()) {
            case R.id.menu_insert_img:
                openGallery();
                break;
            case R.id.menu_new_note:
                createNewNote();
                break;
            case R.id.menu_delete:
                // 创建对话框，询问用户是否删除
                AlertDialog.Builder builder = new AlertDialog.Builder(this);
                builder.setTitle(getString(R.string.alert_title_delete));
                builder.setIcon(android.R.drawable.ic_dialog_alert);
                builder.setMessage(getString(R.string.alert_message_delete_note));
                builder.setPositiveButton(android.R.string.ok,
                        new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int which) {
                                deleteCurrentNote();
                                finish();
                            }
                        });
                builder.setNegativeButton(android.R.string.cancel, null);
                builder.show();
                break;
            case R.id.menu_font_size:
                // 将字体大小选择器和当前字体大小对应的视图设置为可见
                mFontSizeSelector.setVisibility(View.VISIBLE);
                findViewById(sFontSelectorSelectionMap.get(mFontSizeId)).setVisibility(View.VISIBLE);
                break;
            case R.id.menu_change_font_color:
                mTxtColorSelector.setVisibility(View.VISIBLE);
                findViewById(sTxtColorSelectorSelectionMap.get(mTxtColorId)).setVisibility(View.VISIBLE);
                break;
            case R.id.menu_list_mode:
                // 根据当前笔记是否是清单模式，切换到相反的模式，并更新笔记的清单模式属性
                mWorkingNote.setCheckListMode(mWorkingNote.getCheckListMode() == 0 ?
                        TextNote.MODE_CHECK_LIST : 0);
                break;
            case R.id.menu_share:
                getWorkingText();
                // 将文本发送给其他应用
                sendTo(this, mWorkingNote.getContent());
                break;
            case R.id.menu_send_to_desktop:
                // 将当前笔记作为一个快捷方式发送到桌面
                sendToDesktop();
                break;
            case R.id.menu_alert:
                // 设置一个闹钟提醒
                setReminder();
                break;
            case R.id.menu_delete_remind:
                // 将当前笔记的提醒日期设置为0，并更新数据库
                mWorkingNote.setAlertDate(0, false);
                break;
            default:
                break;
        }
        return true;
    }

    // 设置闹钟提醒
    private void setReminder() {
        // 用于显示日期时间选择器对话框
        DateTimePickerDialog d = new DateTimePickerDialog(this, System.currentTimeMillis());
        d.setOnDateTimeSetListener(new OnDateTimeSetListener() {
            // 根据用户选择的日期时间，设置当前笔记的提醒日期，并更新数据库
            public void OnDateTimeSet(AlertDialog dialog, long date) {
                mWorkingNote.setAlertDate(date	, true);
            }
        });
        // 显示对话框，让用户选择一个日期时间
        d.show();
    }

    /**
     * Share note to apps that support {@link Intent#ACTION_SEND} action
     * and {@text/plain} type
     */
    // 与其他应用共享文本信息
    private void sendTo(Context context, String info) {
        Intent intent = new Intent(Intent.ACTION_SEND);
        // 将要共享的文本信息作为额外数据放入意图中
        intent.putExtra(Intent.EXTRA_TEXT, info);
        intent.setType("text/plain");
        // 启动一个活动，让用户选择一个可以接收这个意图的应用
        context.startActivity(intent);
    }

    // 创建一个新便签
    private void createNewNote() {
        // Firstly, save current editing notes
        saveNote();

        // For safety, start a new NoteEditActivity
        finish();
        Intent intent = new Intent(this, NoteEditActivity.class);
        intent.setAction(Intent.ACTION_INSERT_OR_EDIT);
        intent.putExtra(Notes.INTENT_EXTRA_FOLDER_ID, mWorkingNote.getFolderId());
        startActivity(intent);
    }

    // 删除当前便签
    private void deleteCurrentNote() {
        // 如果正在编辑的笔记存有数据
        if (mWorkingNote.existInDatabase()) {
            HashSet<Long> ids = new HashSet<Long>();
            long id = mWorkingNote.getNoteId();
            // 判断是否为根文件夹id
            if (id != Notes.ID_ROOT_FOLDER) {
                ids.add(id);
            } else {
                Log.d(TAG, "Wrong note id, should not happen");
            }
            // 判断当前是否是同步模式
            if (!isSyncMode()) {
                if (!DataUtils.batchDeleteNotes(getContentResolver(), ids)) {
                    Log.e(TAG, "Delete Note error");
                }
            } else {
                if (!DataUtils.batchMoveToFolder(getContentResolver(), ids, Notes.ID_TRASH_FOLER)) {
                    Log.e(TAG, "Move notes to trash folder error, should not happens");
                }
            }
        }
        mWorkingNote.markDeleted(true);
    }

    // 判断是否是同步模式
    private boolean isSyncMode() {
        return NotesPreferenceActivity.getSyncAccountName(this).trim().length() > 0;
    }

    // 笔记闹钟提醒发生变化时调用, set 是是否设置提醒的标志
    public void onClockAlertChanged(long date, boolean set) {
        /**
         * User could set clock to an unsaved note, so before setting the
         * alert clock, we should save the note first
         */
        if (!mWorkingNote.existInDatabase()) {
            saveNote();
        }
        // 大于0,即保存到了数据库中,否则就是未保存到数据库
        if (mWorkingNote.getNoteId() > 0) {
            // 用于发送一个闹钟接收的广播，将当前笔记的uri作为数据放入意图中
            Intent intent = new Intent(this, AlarmReceiver.class);
            intent.setData(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, mWorkingNote.getNoteId()));
            // 用于包装上面的意图对象，以便在闹钟触发时发送广播
            PendingIntent pendingIntent = PendingIntent.getBroadcast(this, 0, intent, 0);
            // 获取一个闹钟管理器对象，用于设置或取消闹钟
            AlarmManager alarmManager = ((AlarmManager) getSystemService(ALARM_SERVICE));
            showAlertHeader();
            // 判断是否设置提醒
            if(!set) {
                // 取消之前设置的闹钟
                alarmManager.cancel(pendingIntent);
            } else {
                // 设置一个在指定日期时间触发的闹钟，并发送待定意图
                alarmManager.set(AlarmManager.RTC_WAKEUP, date, pendingIntent);
            }
        } else {
            /**
             * There is the condition that user has input nothing (the note is
             * not worthy saving), we have no note id, remind the user that he
             * should input something
             */
            Log.e(TAG, "Clock alert setting error");
            showToast(R.string.error_note_empty_for_clock);
        }
    }

    public void onWidgetChanged() {
        updateWidget();
    }

    // 在用户删除某个文本编辑器时，将被删除的文本内容追加到前面或者后面的文本编辑器中，并更新列表的索引值
    public void onEditTextDelete(int index, String text) {
        int childCount = mEditTextList.getChildCount();
        if (childCount == 1) {
            return;
        }

        for (int i = index + 1; i < childCount; i++) {
            ((NoteEditText) mEditTextList.getChildAt(i).findViewById(R.id.et_edit_text))
                    .setIndex(i - 1);
        }

        mEditTextList.removeViewAt(index);
        NoteEditText edit = null;
        if(index == 0) {
            edit = (NoteEditText) mEditTextList.getChildAt(0).findViewById(
                    R.id.et_edit_text);
        } else {
            edit = (NoteEditText) mEditTextList.getChildAt(index - 1).findViewById(
                    R.id.et_edit_text);
        }
        int length = edit.length();
        edit.append(text);
        edit.requestFocus();
        edit.setSelection(length);
    }

    /* 在用户在某个文本编辑器中按下回车键时，创建一个新的文本编辑器，
    *  并将当前的文本内容分割到两个文本编辑器中。
    *  实现在笔记应用中输入多行文本。
    */
    public void onEditTextEnter(int index, String text) {
        /**
         * Should not happen, check for debug
         */
        if(index > mEditTextList.getChildCount()) {
            Log.e(TAG, "Index out of mEditTextList boundrary, should not happen");
        }

        View view = getListItem(text, index);
        mEditTextList.addView(view, index);
        NoteEditText edit = (NoteEditText) view.findViewById(R.id.et_edit_text);
        edit.requestFocus();
        edit.setSelection(0);
        for (int i = index + 1; i < mEditTextList.getChildCount(); i++) {
            ((NoteEditText) mEditTextList.getChildAt(i).findViewById(R.id.et_edit_text))
                    .setIndex(i);
        }
    }

    // 将用户输入的文本转换成多个文本编辑器，以便用户在列表模式下编辑多行文本。
    private void switchToListMode(String text) {
        mEditTextList.removeAllViews();
        String[] items = text.split("\n");
        int index = 0;
        for (String item : items) {
            if(!TextUtils.isEmpty(item)) {
                mEditTextList.addView(getListItem(item, index));
                index++;
            }
        }
        mEditTextList.addView(getListItem("", index));
        mEditTextList.getChildAt(index).findViewById(R.id.et_edit_text).requestFocus();

        mNoteEditor.setVisibility(View.GONE);
        mEditTextList.setVisibility(View.VISIBLE);
    }

    // 将用户输入的搜索关键词在完整文本中高亮显示，以便用户快速定位到相关内容
    private Spannable getHighlightQueryResult(String fullText, String userQuery) {
        SpannableString spannable = new SpannableString(fullText == null ? "" : fullText);
        if (!TextUtils.isEmpty(userQuery)) {
            mPattern = Pattern.compile(userQuery);
            Matcher m = mPattern.matcher(fullText);
            int start = 0;
            while (m.find(start)) {
                spannable.setSpan(
                        new BackgroundColorSpan(this.getResources().getColor(
                                R.color.user_query_highlight)), m.start(), m.end(),
                        Spannable.SPAN_INCLUSIVE_EXCLUSIVE);
                start = m.end();
            }
        }
        return spannable;
    }

    // 根据用户输入的文本内容和搜索关键词创建一个带有复选框和高亮效果的文本编辑器视图
    private View getListItem(String item, int index) {
        View view = LayoutInflater.from(this).inflate(R.layout.note_edit_list_item, null);
        final NoteEditText edit = (NoteEditText) view.findViewById(R.id.et_edit_text);
        edit.setTextAppearance(this, TextAppearanceResources.getTexAppearanceResource(mFontSizeId));
        CheckBox cb = ((CheckBox) view.findViewById(R.id.cb_edit_item));
        cb.setOnCheckedChangeListener(new OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    edit.setPaintFlags(edit.getPaintFlags() | Paint.STRIKE_THRU_TEXT_FLAG);
                } else {
                    edit.setPaintFlags(Paint.ANTI_ALIAS_FLAG | Paint.DEV_KERN_TEXT_FLAG);
                }
            }
        });

        if (item.startsWith(TAG_CHECKED)) {
            cb.setChecked(true);
            edit.setPaintFlags(edit.getPaintFlags() | Paint.STRIKE_THRU_TEXT_FLAG);
            item = item.substring(TAG_CHECKED.length(), item.length()).trim();
        } else if (item.startsWith(TAG_UNCHECKED)) {
            cb.setChecked(false);
            edit.setPaintFlags(Paint.ANTI_ALIAS_FLAG | Paint.DEV_KERN_TEXT_FLAG);
            item = item.substring(TAG_UNCHECKED.length(), item.length()).trim();
        }

        edit.setOnTextViewChangeListener(this);
        edit.setIndex(index);
        edit.setText(getHighlightQueryResult(item, mUserQuery));
        return view;
    }

    // 根据用户在文本编辑器中输入或删除文本时，动态显示或隐藏复选框。
    public void onTextChange(int index, boolean hasText) {
        if (index >= mEditTextList.getChildCount()) {
            Log.e(TAG, "Wrong index, should not happen");
            return;
        }
        if(hasText) {
            mEditTextList.getChildAt(index).findViewById(R.id.cb_edit_item).setVisibility(View.VISIBLE);
        } else {
            mEditTextList.getChildAt(index).findViewById(R.id.cb_edit_item).setVisibility(View.GONE);
        }
    }

    // 根据用户选择的模式，将文本编辑器从普通模式切换到列表模式，或者从列表模式切换到普通模式。
    public void onCheckListModeChanged(int oldMode, int newMode) {
        if (newMode == TextNote.MODE_CHECK_LIST) {
            switchToListMode(mNoteEditor.getText().toString());
        } else {
            if (!getWorkingText()) {
                mWorkingNote.setWorkingText(mWorkingNote.getContent().replace(TAG_UNCHECKED + " ",
                        ""));
            }
            mNoteEditor.setText(getHighlightQueryResult(mWorkingNote.getContent(), mUserQuery));
            mEditTextList.setVisibility(View.GONE);
            mNoteEditor.setVisibility(View.VISIBLE);
        }
    }

    // 根据笔记的模式，从文本编辑器或者文本编辑器列表中获取文本内容
    private boolean getWorkingText() {
        boolean hasChecked = false;
        if (mWorkingNote.getCheckListMode() == TextNote.MODE_CHECK_LIST) {
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < mEditTextList.getChildCount(); i++) {
                View view = mEditTextList.getChildAt(i);
                NoteEditText edit = (NoteEditText) view.findViewById(R.id.et_edit_text);
                if (!TextUtils.isEmpty(edit.getText())) {
                    if (((CheckBox) view.findViewById(R.id.cb_edit_item)).isChecked()) {
                        sb.append(TAG_CHECKED).append(" ").append(edit.getText()).append("\n");
                        hasChecked = true;
                    } else {
                        sb.append(TAG_UNCHECKED).append(" ").append(edit.getText()).append("\n");
                    }
                }
            }
            mWorkingNote.setWorkingText(sb.toString());
        } else {
            mWorkingNote.setWorkingText(mNoteEditor.getText().toString());
        }
        return hasChecked;
    }

    // 用于保存一个笔记应用的文本内容
    private boolean saveNote() {
        getWorkingText();
        boolean saved = mWorkingNote.saveNote();
        if (saved) {
            /**
             * There are two modes from List view to edit view, open one note,
             * create/edit a node. Opening node requires to the original
             * position in the list when back from edit view, while creating a
             * new node requires to the top of the list. This code
             * {@link #RESULT_OK} is used to identify the create/edit state
             */
            setResult(RESULT_OK);
        }
        return saved;
    }

    // 将笔记内容发送到桌面
    private void sendToDesktop() {
        /**
         * Before send message to home, we should make sure that current
         * editing note is exists in databases. So, for new note, firstly
         * save it
         */
        if (!mWorkingNote.existInDatabase()) {
            saveNote();
        }

        if (mWorkingNote.getNoteId() > 0) {
            Intent sender = new Intent();
            Intent shortcutIntent = new Intent(this, NoteEditActivity.class);
            shortcutIntent.setAction(Intent.ACTION_VIEW);
            shortcutIntent.putExtra(Intent.EXTRA_UID, mWorkingNote.getNoteId());
            sender.putExtra(Intent.EXTRA_SHORTCUT_INTENT, shortcutIntent);
            sender.putExtra(Intent.EXTRA_SHORTCUT_NAME,
                    makeShortcutIconTitle(mWorkingNote.getContent()));
            sender.putExtra(Intent.EXTRA_SHORTCUT_ICON_RESOURCE,
                    Intent.ShortcutIconResource.fromContext(this, R.drawable.icon_app));
            sender.putExtra("duplicate", true);
            sender.setAction("com.android.launcher.action.INSTALL_SHORTCUT");
            showToast(R.string.info_note_enter_desktop);
            sendBroadcast(sender);
        } else {
            /**
             * There is the condition that user has input nothing (the note is
             * not worthy saving), we have no note id, remind the user that he
             * should input something
             */
            Log.e(TAG, "Send to desktop error");
            showToast(R.string.error_note_empty_for_send_to_desktop);
        }
    }

    // 用于编辑小图标的标题
    private String makeShortcutIconTitle(String content) {
        content = content.replace(TAG_CHECKED, "");
        content = content.replace(TAG_UNCHECKED, "");
        return content.length() > SHORTCUT_ICON_TITLE_MAX_LEN ? content.substring(0,
                SHORTCUT_ICON_TITLE_MAX_LEN) : content;
    }

    // 显示提示的视图
    private void showToast(int resId) {
        showToast(resId, Toast.LENGTH_SHORT);
    }

    // 持续显示提示视图
    private void showToast(int resId, int duration) {
        Toast.makeText(this, resId, duration).show();
    }
    //-----------------------------------------------------------------------------------------//
    //-----------------------------------施-----工-----区---------------------------------------//
    //-----------------------------------------------------------------------------------------//
    //--------------------------------注-----意-----安-----全-----------------------------------//
    //-----------------------------------------------------------------------------------------//
    //--------------------------更改请遵循636softwareDevGroup开发共识-----------------------------//
    //-----------------------------------------------------------------------------------------//
    //----------------------------Last---Change---2023---04---27-------------------------------//
    //-----------------------------------------------------------------------------------------//
    //----------------------------------By-K4sumizawaMiyU--------------------------------------//
    //-----------------------------------------------------------------------------------------//
    //--------------------------Miyu--Wa--SeiKai--1st--Kawaii!---------------------------------//
    // 数据流获取
    public String getDataColumn(Context context, Uri uri, String selection, String[] selectionArgs) {
        Cursor cursor = null;
        final String column = "_data";
        final String[] projection = {column};
        try{
            cursor = context.getContentResolver().query(uri, projection, selection,
                    selectionArgs, null);
            if (cursor != null && cursor.moveToFirst()) {
                final int column_index = cursor.getColumnIndexOrThrow(column);
                return cursor.getString(column_index);
            }
        } finally {
            if (cursor != null)
                cursor.close();
        }
        return null;
    }
    // 用于开启多媒体相册
    public void openGallery() {
        Intent loadImg = new Intent(Intent.ACTION_GET_CONTENT);
        loadImg.addCategory(Intent.CATEGORY_OPENABLE);
        loadImg.setType("image/*");
        startActivityForResult(loadImg, OPEN_GALLERY);
    }
    // 用于取得图片路径
    public String getPath(final Context context, final Uri uri) {
        final boolean isKitKat = Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT;
        if (isKitKat && DocumentsContract.isDocumentUri(context, uri)) {
            if (isMediaDocument(uri)) {
                final String docId = DocumentsContract.getDocumentId(uri);
                final String[] split = docId.split(":");
                final String type = split[0];

                Uri contentUri = null;
                if ("image".equals(type)) {
                    contentUri = MediaStore.Images.Media.EXTERNAL_CONTENT_URI;
                }
                final String selection = "_id=?";
                final String[] selectionArgs = new String[]{split[1]};

                return getDataColumn(context, contentUri, selection, selectionArgs);
            }
        } else if ("content".equalsIgnoreCase(uri.getScheme())) {
            return getDataColumn(context, uri, null, null);
        } else if ("file".equalsIgnoreCase(uri.getScheme())) {
            return uri.getPath();
        }
        return null;
    }
    // 路径地址转换为图片
    private void convertToImg() {
        NoteEditText noteEditText = (NoteEditText) findViewById(R.id.note_edit_view);
        Editable editable = noteEditText.getText();
        String noteTxt= editable.toString();
        int length = editable.length();
        for(int i = 0;i < length;i ++) {
            for(int j = i;j < length;j ++) {
                String img_frag = noteTxt.substring(i, j+1);
                if(img_frag.length() > 15 && img_frag.endsWith("[/local]")&& img_frag.startsWith("[local]")) {
                    int lim = 7;
                    int len = img_frag.length() - 15;
                    String path = img_frag.substring(lim, lim + len);
                    Bitmap bitmap = null;
                    Log.d(TAG,"img from:"+path);
                    try {
                        bitmap = BitmapFactory.decodeFile(path);
                    } catch (Exception err) {
                        err.printStackTrace();
                    } if(bitmap != null) {
                        Log.d(TAG,"img not null");
                        ImageSpan imageSpan = new ImageSpan(NoteEditActivity.this, bitmap);
                        String ss = "[local]" + path + "[/local]";
                        SpannableString spannableString = new SpannableString(ss);
                        spannableString.setSpan(imageSpan, 0, ss.length(), Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
                        Log.d(TAG,"success!");
                        Editable edit_txt = noteEditText.getEditableText();
                        edit_txt.delete(i, i + len + 15);
                        edit_txt.insert(i, spannableString);
                    }
                }
            }
        }
    }
    // 重写onActivityResult处理返回的数据
    protected void onActivityResult(int requestCode, int resultCode, Intent intent) {
        super.onActivityResult(requestCode, resultCode, intent);
        ContentResolver resolver = getContentResolver();
        switch (requestCode) {
            case OPEN_GALLERY:
                Uri originUri = intent.getData();
                Bitmap bitmap = null;
                try {
                    bitmap = BitmapFactory.decodeStream(resolver.openInputStream(originUri));
                } catch (FileNotFoundException err) {
                    Log.d(TAG,"get file_exception");
                    err.printStackTrace();
                } if(bitmap != null) {
                    Log.d(TAG,"Bitmap is not null");
                    ImageSpan imageSpan = new ImageSpan(NoteEditActivity.this, bitmap);
                    String path = getPath(this, originUri);
                    String img_frag= "[local]" + path + "[/local]";
                    // 创建一个SpannableString对象，以便插入用ImageSpan对象封装的图像
                    SpannableString spannableString = new SpannableString(img_frag);
                    spannableString.setSpan(imageSpan, 0, img_frag.length(), Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
                    // 将图片插入光标所在位置
                    NoteEditText  img = (NoteEditText) findViewById(R.id.note_edit_view);
                    int index = img.getSelectionStart();
                    Log.d(TAG,"Index is:" + index);
                    Editable edit_txt = img.getEditableText();
                    edit_txt.insert(index, spannableString);
                    mWorkingNote.mContent = img.getText().toString();
                    // 将改动提交至数据库
                    ContentResolver contentResolver = getContentResolver();
                    ContentValues contentValues = new ContentValues();
                    final long id = mWorkingNote.getNoteId();
                    contentValues.put("snippet",mWorkingNote.mContent);
                    contentResolver.update(Uri.parse("content://micode_notes/note"), contentValues,"picture=?",new String[]{""+id});
                    ContentValues contentValues1 = new ContentValues();
                    contentValues1.put("content",mWorkingNote.mContent);
                    contentResolver.update(Uri.parse("content://micode_notes/data"), contentValues1,"mime_type=? and note_id=?", new String[]{"vnd.android.cursor.item/text_note",""+id});
                } else {
                Toast.makeText(NoteEditActivity.this, "获取图片失败", Toast.LENGTH_SHORT).show();
                }
                break;
            default:
                break;
        }
    }
    // 判断所选文档是否为多媒体文件
    public boolean isMediaDocument(Uri uri) {
        return "com.android.providers.media.documents".equals(uri.getAuthority());
    }
}
